{{ define "main" }}

{{ $projects := slice }}
{{ $funders := slice }}
{{ range $index, $project := $.Site.Data.c19dpes_research_projects.research_projects }}
{{ $correct_type := true }}
{{ $has_data := true }}
  {{ if and $has_data $correct_type }}
    {{ $projects = $projects | append $project }}
    
      {{ if in $funders $project.funder}}
      {{ else }}
        {{ if ne $project.funder "" }}
          {{ $funders = $funders | append $project.funder }}
        {{ end }}
      {{ end }}

  {{ end }}
{{ end }}
{{ $funders = sort $funders }}

<main class="container">
  <h1>{{ .Title }}</h1>
  <article>{{ .Content }}</article>
  <div class="d-flex">
    {{ partial "last-update.html" (dict "context" . "last_update" (substr $.Site.Data.c19dpes_research_projects.timestamp 0 10)) }}
  </div>
  <div class="row">
    <section class="col-md-2">
      <h5>{{ i18n "funding_call" }}</h5>
      <div class="form-check mb-2 ml-3">
        <div class="row">
          <input type="checkbox" class="form-check-input" name="funding_call" value="Registro">
          <span>{{ i18n "registro_covid" }}</span>
        </div>
      </div>
      <!--<h5>{{ i18n "organisation" }}</h5>
      <div class="form-check mb-2 ml-3">
        <div class="row">
          <input type="checkbox" class="form-check-input" name="uni_or_multi" value="Unicentric">
          <span>{{ i18n "unicentric" }}</span>
        </div>
        <div class="row">
          <input type="checkbox" class="form-check-input" name="uni_or_multi" value="Multicentric">
          <span>{{ i18n "multicentric" }}</span>
        </div>
      </div>
      <h5>{{ i18n "clinical_trial" }}</h5>
      <div class="form-check mb-2 ml-3">
        <div class="row">
          <input type="checkbox" class="form-check-input" name="clinical_trial" value="Yes">
          <span>{{ i18n "yes" }}</span>
        </div>
        <div class="row">
          <input type="checkbox" class="form-check-input" name="clinical_trial" value="No">
          <span>{{ i18n "no" }}</span>
        </div>
      </div>-->
      <h5>{{ i18n "funder" }}</h5>
      <div class="form-check mb-2 ml-3">
        {{ range $index, $funder := $funders }}
        <div class="row">
          <input type="checkbox" class="form-check-input" name="funder" value="{{ $funder }}">
          <span>{{ $funder }}</span>
        </div>
        {{ end }}
      </div>
    </section>
    <div class="col-md-10">
      <a id="downloadButton" class="btn btn-primary d-inline-block" target="_blank" href="http://eu-isciii.es/wp-content/uploads/2020/06/Excel-COVID19-Funded-Spain-Projects-v.04.06.2020.xlsx">
        {{ i18n "download_csv" }}
      </a>
      <table class="table table-responsive" id="projects-table">
        <thead class="thead-light">
          <tr>
            <th scope="col">{{ i18n "project" }}</th>
            <th scope="col">{{ i18n "reference_id" }}</th>

            <!-- This columns are not visible by DataTables but they are necessary for filtering and CSV downloading -->
            <th scope="col">{{ i18n "center" }}</th>
            <th scope="col">{{ i18n "pi" }}</th>
            <th scope="col">{{ i18n "funder" }}</th>
            <th scope="col">{{ i18n "funding_call" }}</th>
          </tr>
        </thead>
        <tbody>
          {{ range $index, $project := $projects }}
            <tr>
              <td>
                <b>{{ .title }}{{ if .acronym }} ({{ .acronym }}){{ end }} </b><br>
                {{ if isset . "pi" }}<span class="text-muted">{{ .pi }}</span><br>{{ end }}
                {{ if isset . "center" }}<i>{{ .center }}</i><br>{{ end }}
                <!--<small><b>Organization:</b> {{ .uni_multi_centric }}</small><br>
                <small><b>Clinical trial:</b> {{ .clinical_trial }}</small><br>-->
                {{ if isset . "funder" }}<small><b>Funder:</b> {{ .funder }}</small><br>{{ end }}
                {{ if isset . "topic_call" }}<small><b>Topic call:</b> {{ delimit .topic_call ", " }}</small><br>{{ end }}
                {{ if isset . "primary_who_research_area" }}<small><b>Primary WHO research area:</b> {{ .primary_who_research_area }}</small><br>{{ end }}
                {{ if .description }}
                <a class="badge badge-primary dp-background-color--primary" data-toggle="collapse" href="#description{{ $index }}" role="button" aria-expanded="false" aria-controls="description{{ $index }}">
                  {{ i18n "description" }} <i class="bi bi-caret-down-fill"></i>
                </a>
                <div class="collapse" id="description{{ $index }}">
                  <div class="card card-body">{{ safeHTML .description }}</div>
                </div>
                {{ end }}
              </td>
              <td>{{ .funder_reference }}</td>

              <!-- This columns are not visible by DataTables but they are necessary for filtering and CSV downloading -->
              <td>{{ .center }}</td>
              <td>{{ if isset . "pi" }}{{ .pi }}{{ end }}</td>
              <td>{{ if isset . "funder" }}{{ .funder }}{{ end }}</td>
              <td>{{ if isset . "funding_call" }}{{ .funding_call }}{{ end }}</td>
            </tr>
          {{ end }}
        </tbody>
      </table>
    </div>
  </div>
</main>

<script src="/js/dp-table-filters.js"></script>
<script>
  $(document).ready(function() {
    const table = $('#projects-table').DataTable({
      dom: `
        <".container-fluid"
          <".row my-2"
            <".mr-auto"i>
            <"#search.mr-2"f>
          >
          <".row"t>
          <".row"
            <".mr-auto"l>
            <".ml-auto"p>
          >
        >
      `,
      buttons: [
        {
          extend: 'csv',
          text: 'Download as CSV',
          titleAttr: 'Download table in comma-separated-values format',
          className: 'btn btn-primary',
          exportOptions: {
            columns: [ 1, 2, 3, 4, 5, 6 ],
          },
        },
      ],
      processing: true,
      order: [[ 0, "desc" ]],
      autoWidth: false,
      columnDefs: [

        // Hide columns that are present for filtering and for downloading the table as usable CSV.
        { visible: false, targets: [2, 3, 4, 5] },

        // Remove ordering for first mega-column (sorting alphabetically by title makes no sense).
        { orderable: true, targets: 0 },
      ],
    });

    // Move download buttons next to filter search box.
    const downloadButton = document.querySelector('#downloadButton');
    downloadButton.classList.remove('btn-group', 'flex-wrap');
    downloadButton.classList.add('d-flex');
    const search = document.querySelector('#search');
    search.insertAdjacentElement('afterend', downloadButton);

    // Define column indices and apply checkbox filters.
    const columnIndices = {
      center: 2,
      pi: 3,
      funder: 4,
      funding_call: 5
    };
    applyFilters(table, columnIndices);
});
</script>

{{ end }}
